Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# Ogre::LogManager Class Reference

The log manager handles the creation and retrieval of logs for the application. More...

`#include <OgreLogManager.h>`

Inheritance diagram for Ogre::LogManager:

[legend]
List of all members.

## Public Methods

| LogManager ()
| ~LogManager ()
Log * | createLog (const String &name, bool defaultLog=false, bool debuggerOutput=true)
| Creates a new log with the given name.
Log * | getLog (const String &name)
| Retrieves a log managed by this class.
Log * | getDefaultLog ()
| Returns a pointer to the default log.
Log * | setDefaultLog (Log *newLog)
| Sets the passed in log as the default log.
void | logMessage (const String &message, LogMessageLevel lml=LML_NORMAL, bool maskDebug=false)
| Log a message to the default log.
void | logMessage (LogMessageLevel lml, const char *szMessage,...)
| Log a message, smarter form - allows a variable number of arguments.
void | setLogDetail (LoggingLevel ll)
| Sets the level of detail of the default log.

## Static Public Methods

LogManager & | getSingleton (void)
| Override standard Singleton retrieval.
LogManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.

## Protected Types

typedef std::map< String, Log *, std::less< String > > | LogList

## Protected Attributes

LogList | mLogs
| A list of all the logs the manager can access.
Log * | mDefaultLog
| The default log to which output is done.

## Static Protected Attributes

LogManager * | ms_Singleton = 0

## Detailed Description

The log manager handles the creation and retrieval of logs for the application.

Remarks:
  This class will create new log files and will retrieve instances of existing ones. Other classes wishing to log output can either create a fresh log or retrieve an existing one to output to. One log is the default log, and is the one written to when the logging methods of this class are called.

Definition at line 46 of file OgreLogManager.h.

## Member Typedef Documentation

typedef std::map<String, Log*, std::less<String> > Ogre::LogManager::LogList`[protected]`

| Definition at line 49 of file OgreLogManager.h.

## Constructor & Destructor Documentation

Ogre::LogManager::LogManager | ( |  | ) |

| Definition at line 48 of file OgreLogManager.cpp. References mDefaultLog.

Ogre::LogManager::~LogManager | ( |  | ) |

| Definition at line 53 of file OgreLogManager.cpp. References mLogs.

## Member Function Documentation

Log * Ogre::LogManager::createLog | ( | const String & | name,
|  | bool | defaultLog = false,
|  | bool | debuggerOutput = true
| ) |

Creates a new log with the given name.

Parameters:

  name | The name to give the log e.g. 'Ogre.log'
  defaultLog | If true, this is the default log output will be sent to if the generic logging methods on this class are used. The first log created is always the default log unless this parameter is set.
  debuggerOutput | If true, output to this log will also be routed to the debugger's output window.

Definition at line 63 of file OgreLogManager.cpp.

References mDefaultLog, mLogs, and Ogre::String.

Referenced by Ogre::Root::Root().

Log * Ogre::LogManager::getDefaultLog | ( |  | ) |

| Returns a pointer to the default log. Definition at line 77 of file OgreLogManager.cpp. References Except, and mDefaultLog. Referenced by logMessage(), and setLogDetail().

Log * Ogre::LogManager::getLog | ( | const String & | name | ) |

| Retrieves a log managed by this class. Definition at line 92 of file OgreLogManager.cpp. References Except, mLogs, and Ogre::String.

LogManager & Ogre::LogManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< LogManager >.

Definition at line 43 of file OgreLogManager.cpp.

References Ogre::Singleton< LogManager >::ms_Singleton.

LogManager * Ogre::LogManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< LogManager >.

Definition at line 39 of file OgreLogManager.cpp.

References Ogre::Singleton< LogManager >::ms_Singleton.

void Ogre::LogManager::logMessage | ( | LogMessageLevel | lml,
|  | const char * | szMessage,
|  | ... |
| ) |

Log a message, smarter form - allows a variable number of arguments.

Note:
  The longest string that this function can output is 4096 characters long.

Definition at line 108 of file OgreLogManager.cpp.

References getDefaultLog(), Ogre::Log::logMessage(), and Ogre::LogMessageLevel.

void Ogre::LogManager::logMessage | ( | const String & | message,
|  | LogMessageLevel | lml = LML_NORMAL,
|  | bool | maskDebug = false
| ) |

| Log a message to the default log. Definition at line 103 of file OgreLogManager.cpp. References getDefaultLog(), Ogre::Log::logMessage(), Ogre::LogMessageLevel, and Ogre::String. Referenced by Ogre::Root::Root(), and Ogre::Root::shutdown().

Log * Ogre::LogManager::setDefaultLog | ( | Log * | newLog | ) |

Sets the passed in log as the default log.

Returns:
  The previous default log.

Definition at line 85 of file OgreLogManager.cpp.

References mDefaultLog.

void Ogre::LogManager::setLogDetail | ( | LoggingLevel | ll | ) |

| Sets the level of detail of the default log. Definition at line 120 of file OgreLogManager.cpp. References getDefaultLog(), Ogre::LoggingLevel, and Ogre::Log::setLogDetail().

## Member Data Documentation

Log* Ogre::LogManager::mDefaultLog`[protected]`

| The default log to which output is done. Definition at line 55 of file OgreLogManager.h. Referenced by createLog(), getDefaultLog(), LogManager(), and setDefaultLog().

LogList Ogre::LogManager::mLogs`[protected]`

| A list of all the logs the manager can access. Definition at line 52 of file OgreLogManager.h. Referenced by createLog(), getLog(), and ~LogManager().

LogManager * Ogre::Singleton< LogManager >::ms_Singleton = 0`[static, protected, inherited]`

| Definition at line 38 of file OgreLogManager.cpp. Referenced by getSingleton(), and getSingletonPtr().

The documentation for this class was generated from the following files:

- OgreLogManager.h
- OgreLogManager.cpp

Copyright © 2002-2003 by The OGRE Team
Last modified Sun Nov 28 19:51:10 2004